"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const prompt = __importStar(require("prompt"));
const request_1 = require("./util/request");
const token_1 = require("./token");
const promise_1 = require("./util/promise");
const log_1 = require("./util/log");
const log_2 = require("./util/log");
prompt.start();
const defaultReadEmail = savedEmail => promise_1.fromCallback(cb => prompt.get({
    properties: {
        email: {
            default: savedEmail,
            description: 'Enter your email',
            message: 'The specified value must be a valid email address.',
            pattern: /^([\w-.]+)@([\w-.]+)\.([a-z]{2,5})$/i,
            required: true
        }
    }
}, cb)).then(ret => ret.email);
const defaultReadCode = () => promise_1.fromCallback(cb => prompt.get({
    'properties': {
        'code': {
            'description': 'Enter your code',
            'hide': true,
            'required': true
        }
    }
}, cb)).then(ret => ret.code);
async function authenticate(options) {
    log_2.debug('authenticate called');
    const { authAPI, validateAPI, readEmail = defaultReadEmail, readCode = defaultReadCode } = options;
    const info = await token_1.getToken();
    const email = await readEmail(info.email);
    log_2.debug('email input:', email);
    info.email = email;
    await token_1.writeToken(info);
    await request_1.postURLEncoded(authAPI, { email });
    log_1.log('We\'ve already sent the code to your email.');
    const code = await readCode();
    log_2.debug('code input:', code);
    info.code = code;
    await token_1.writeToken(info);
    const res = await request_1.postURLEncoded(validateAPI, {
        'code': info.code,
        'email': info.email
    });
    info.token = res['data'].token;
    await token_1.writeToken(info);
}
exports.authenticate = authenticate;
