import { LogLevel } from './util/log';
declare type OptionsPath = string;
declare type OptionsLiteral = {
    receiver: string;
    logLevel: LogLevel;
    recursive: boolean;
    retry: number;
    fastFail: boolean;
    concurrent: number;
    parallelPushCount: number;
    readEmail: (savedEmail: string) => Promise<string>;
    readCode: () => Promise<string>;
    dryrun: boolean;
};
export declare type Options = OptionsPath | Partial<OptionsLiteral>;
export interface NormalizedOptions extends Partial<OptionsLiteral> {
    receiver: string;
    retry: number;
    concurrent: number;
    uploadAPI: string;
    authAPI: string;
    validateAPI: string;
    normalized: true;
}
export declare function normalize(raw: Options, additional?: Partial<OptionsLiteral>): NormalizedOptions;
export declare function isNormalizedOptions(options: Options | NormalizedOptions): options is NormalizedOptions;
export {};
