"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = __importDefault(require("fs"));
const path_1 = require("path");
const util_1 = require("util");
exports.readFile = util_1.promisify(fs_1.default.readFile);
exports.writeFile = util_1.promisify(fs_1.default.writeFile);
exports.stat = util_1.promisify(fs_1.default.stat);
exports.readdir = util_1.promisify(fs_1.default.readdir);
exports.exists = file => exports.stat(file).catch(e => {
    if (e.code === 'ENOENT')
        return false;
    throw e;
});
async function listFilesRecursively(dirPath, files = []) {
    for (const file of await exports.readdir(dirPath)) {
        const fileStat = await exports.stat(dirPath + '/' + file);
        if (fileStat.isDirectory())
            await listFilesRecursively(dirPath + '/' + file, files);
        else
            files.push(path_1.join(dirPath, '/', file));
    }
    return files;
}
exports.listFilesRecursively = listFilesRecursively;
