export declare enum OutStream {
    STDOUT = 0,
    STDERR = 1
}
export declare enum LogLevel {
    NONE = 5,
    ERROR = 4,
    WARN = 3,
    INFO = 2,
    DEBUG = 1
}
export declare function setLogLevel(level: LogLevel): void;
export declare function getLogLevel(): LogLevel;
export declare function setLogImpl(newImpl: any): void;
export declare function getLogImpl(): {
    (message?: any, ...optionalParams: any[]): void;
    (message?: any, ...optionalParams: any[]): void;
}[];
export declare function restoreLogImpl(): void;
/**
 * Log Interfaces
 */
export declare function error(...args: any[]): any[];
export declare function warn(...args: any[]): any[];
export declare function success(...args: any[]): any[];
export declare function log(...args: any[]): any[];
export declare function raw(...args: any[]): void;
export declare function debug(...args: any[]): any[];
export declare function dateStr(now?: Date): string;
export declare function doLog(out: OutStream, level: LogLevel, color: string, ...args: any[]): any[];
